"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withOffline = void 0;
var workbox_webpack_plugin_1 = require("workbox-webpack-plugin");
var copy_webpack_plugin_1 = __importDefault(require("copy-webpack-plugin"));
var node_fs_1 = require("node:fs");
var node_path_1 = require("node:path");
var node_process_1 = require("node:process");
var export_1 = require("./export");
// Next build metadata files that shouldn't be included in the pre-cache manifest.
var preCacheManifestBlacklist = ['react-loadable-manifest.json', 'build-manifest.json', /\.map$/];
var defaultInjectOpts = {
    swSrc: undefined,
    exclude: preCacheManifestBlacklist,
    modifyURLPrefix: {
        'static/': '_next/static/',
        'public/': '_next/public/',
    },
};
var defaultGenerateOpts = __assign(__assign({}, defaultInjectOpts), { 
    // As of Workbox v5 Alpha there isn't a well documented way to move workbox runtime into the directory
    // required by Next. As a workaround, we inline the tree-shaken runtime into the main Service Worker file
    // at the cost of less reachability
    inlineWorkboxRuntime: true, runtimeCaching: [
        {
            urlPattern: /^https?.*/,
            handler: 'NetworkFirst',
            options: {
                cacheName: 'offlineCache',
                expiration: {
                    maxEntries: 200,
                },
            },
        },
    ] });
function withOffline(nextConfig) {
    if (nextConfig === void 0) { nextConfig = {}; }
    return __assign(__assign({}, nextConfig), { exportPathMap: (0, export_1.exportSw)(nextConfig), webpack: function (config, context) {
            var _this = this;
            if (!context.defaultLoaders) {
                throw new Error('This plugin is not compatible with Next.js versions below 5.0.0 https://err.sh/next-plugins/upgrade');
            }
            var _a = nextConfig.devSwSrc, devSwSrc = _a === void 0 ? (0, node_path_1.join)(__dirname, 'service-worker.js') : _a, _b = nextConfig.dontAutoRegisterSw, dontAutoRegisterSw = _b === void 0 ? false : _b, _c = nextConfig.generateInDevMode, generateInDevMode = _c === void 0 ? false : _c, _d = nextConfig.generateSw, generateSw = _d === void 0 ? true : _d, 
            // Before adjusting "registerSwPrefix" or "scope", read:
            // https://developers.google.com/web/ilt/pwa/introduction-to-service-worker#registration_and_scope
            _e = nextConfig.registerSwPrefix, 
            // Before adjusting "registerSwPrefix" or "scope", read:
            // https://developers.google.com/web/ilt/pwa/introduction-to-service-worker#registration_and_scope
            registerSwPrefix = _e === void 0 ? '' : _e, _f = nextConfig.scope, scope = _f === void 0 ? '/' : _f, _g = nextConfig.workboxOpts, workboxOpts = _g === void 0 ? {} : _g, _h = nextConfig.nextAssetDirectory, nextAssetDirectory = _h === void 0 ? 'public' : _h;
            var skipDuringDevelopment = context.dev && !generateInDevMode;
            // Generate SW
            if (skipDuringDevelopment) {
                // Simply copy development service worker.
                config.plugins.push(new copy_webpack_plugin_1.default({ patterns: [devSwSrc] }));
            }
            else if (!context.isServer) {
                // Only run once for the client build.
                config.plugins.push(
                // Workbox uses Webpack asset manifest to generate the SW's pre-cache manifest, so we need
                // to copy the app's assets into the Webpack context so those are picked up.
                new copy_webpack_plugin_1.default({ patterns: [{ from: "".concat((0, node_path_1.join)((0, node_process_1.cwd)(), nextAssetDirectory), "/**/*") }] }), generateSw ? new workbox_webpack_plugin_1.GenerateSW(__assign(__assign({}, defaultGenerateOpts), workboxOpts)) : new workbox_webpack_plugin_1.InjectManifest(__assign(__assign({}, defaultInjectOpts), workboxOpts)));
            }
            if (!skipDuringDevelopment) {
                // Register SW
                var originalEntry_1 = config.entry;
                config.entry = function () { return __awaiter(_this, void 0, void 0, function () {
                    var entries, swCompiledPath, content;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, originalEntry_1()];
                            case 1:
                                entries = _a.sent();
                                swCompiledPath = (0, node_path_1.join)(__dirname, 'register-sw-compiled.js');
                                // See https://github.com/zeit/next.js/blob/canary/examples/with-polyfills/next.config.js for a reference on how to add new entrypoints
                                if (entries['main.js'] && !entries['main.js'].includes(swCompiledPath) && !dontAutoRegisterSw) {
                                    content = (0, node_fs_1.readFileSync)(require.resolve('./register-sw.js'), 'utf8');
                                    content = content.replace('{REGISTER_SW_PREFIX}', registerSwPrefix);
                                    content = content.replace('{SW_SCOPE}', scope);
                                    (0, node_fs_1.writeFileSync)(swCompiledPath, content, 'utf8');
                                    entries['main.js'].unshift(swCompiledPath);
                                }
                                return [2 /*return*/, entries];
                        }
                    });
                }); };
            }
            if (typeof nextConfig.webpack === 'function') {
                return nextConfig.webpack(config, context);
            }
            return config;
        } });
}
exports.withOffline = withOffline;
exports.default = withOffline;
//# sourceMappingURL=index.js.map